<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Массивы 2</title>
</head>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
<body>

<script type=text/javascript>

var studentsAndPoints = ['Алексей Петров',0, 'Ирина Овчинникова',60,'Глеб Стукалов',30,'Антон Павлович',30,'Виктория Заровская',30,'Алексей Левенец',70,'Тимур Вамуш',30,'Евгений Прочан',60,'Александр Малов',0];

/*Создаем два массива*/
var points = studentsAndPoints.filter(function(point){
	return typeof point == 'number';
});
 
var students = studentsAndPoints.filter(function(student){
	return typeof student == 'string';
});
 
/*Выводим список студентов*/
document.write('Список студентов: <br />');

students.forEach(function(student, i){
	document.write(' Студент ' + student + ' набрал ' + points[i] + ' баллов <br />');
});
 
/*Найти студента набравшего наибольшее количество баллов*/
var maxStudent = students[0], maxPoint = points[0];
points.forEach(function(point, i){
	if (point > maxPoint){
		maxPoint = point;
		maxStudent = students[i];
	}
});
document.write('<br />Студент набравший максимальный балл: '+maxStudent+' ( '+maxPoint+' баллов )<br />');


/*Используя метод массива map увеличить баллы студентам «Ирина Овчинникова» и «Александр Малов» на 30.*/
function newPoints(student, newPoint){
  students.map(function(name, i){
	if (name == student){
	var totalPoints = points[i]+newPoint;
	points.splice(i,1,totalPoints);
	document.write ('<br />Студент набравший дополнительные баллы: <br />Студент ' + student + ' набрал дополнительно '+newPoint+' баллов.<br />Сейчас у студента всего '+totalPoints+ ' баллов<br />');
	}
  });
}
newPoints('Ирина Овчинникова',30);
newPoints('Александр Малов',30);

/*ДОРАБОТКА ПО ДЗ*/
/*Не стоит игнорировать массив который эта функция возвращает. Иначе она работает как обычный forEach. 
Попробуйте реализовать код так, чтобы map вернула массив увелеченных баллов.*/

document.write('<br /><b>Доработка по дз:</b><br />');
 
function addNewPoints(student,newPoint){
points = points.map(function(point, i) {
	  if (students[i] == student) {
	 var totalPoints = point + newPoint; 	
	 document.write ('<br />Студент набравший дополнительные баллы: <br />Студент ' + student + ' набрал дополнительно '+newPoint+' баллов.<br />Сейчас у студента всего: '+totalPoints+' баллов<br />');
	    return point + newPoint;
	}else {
	    return point;
	  }
	});
}
addNewPoints('Ирина Овчинникова', 30);
addNewPoints('Александр Малов', 30);
 

/*ДОРАБОТКА ПО ДЗ Топ*/

document.write('<br /><b>Доработка по дз Топ:</b><br />');
  
var topStudents = [];

function getTop(topNumber){
document.write('<br />Топ '+ topNumber + ' : <br />');
  	if(topNumber > points.length){
   topNumber = points.length; 
  	}; 
	for(var i = 0; i < topNumber; i++){
		var topPoint = points[0], topIndex = 0;
		points.forEach(function(point, i){
			if(point > topPoint){
			   topPoint = point;
			   topIndex = i;  
			}
		});
		document.write(students[topIndex]+' - '+ topPoint+' баллов<br />');		
		topStudents.push(students[topIndex], topPoint);
		points.splice(topIndex,1);
		students.splice(topIndex,1);
	}
document.write('<br /><a href="students2.html">назад</a>');
}
document.write('<br /><button class="btn">Узнать топ студентов в группе</button><br /><br /><br /><br />');
$(document).ready(function(){
$('.btn').click(function(){getTop(prompt('Введите число студентов'))});
}); 
			


		 
   





/*Дополнительное задание Топ*/	
/*var topStudents = [];
points.forEach(function(point, i){
topStudents.push([[students[i]],[point]]);
});

points.sort(function(a,b){
	return a < b;
});

for (var i in topStudents){
  for (var j in points){
    if(topStudents[i][1] == points[j]){
    points.splice(j,1,topStudents[i]);
    break;
    }
  }
} 

function getTopStudents(topNumber){
   document.write('<br />Топ '+ topNumber + ' : <br />');
	for (var i = 0; i < topNumber; i++) {
		if (topNumber > 0 && topNumber <= points.length) {
		document.write(points[i][0]+' - '+points[i][1]+' баллов<br />');		
		}
	}
   document.write('<br /><a href="students2.html">назад</a>');
}

document.write('<br /><button class="btn">Узнать топ студентов в группе</button>');
$(document).ready(function(){
$('.btn').click(function(){getTopStudents(prompt('Введите число студентов'))});
}); 
*/





</script>

</body>
</html>